/*       Program to implement GAUSS ELIMINATION METHOD.
	 Used to solve the system of simultaneous euquations.

	 Program by : G. P Potdar                                */


# include <stdio.h>
# include <conio.h>
# include <math.h>
# define SIZE 3       /* define the maximum number of equations */


float a[SIZE][SIZE],cons[SIZE],x[SIZE];

/*-------------end of declarations-------------------------------*/

void accept(int n)

/* function to accept the equation */
{
	int i,j;
	clrscr();
	for ( i = 0; i < n; i++ )
	{
		clrscr();
		printf("EQUATION NUMBER %d\n\n",(i + 1));
		for ( j = 0; j < n; j++ )
		{
			printf("COEFFICIENT OF X%d : ",(j + 1));
			scanf("%f",&a[i][j]);
		}
		printf("\n\n");
		printf("ENTER THE CONSTANT TERM : ");
		scanf("%f",&cons[i]);
		getch();
	}
}

/*---------------------end of function accept---------------------*/

void display(int n)
/* function to display the  roots */
{
	int i;
	gotoxy(15,10);
	printf("ROOT");
	gotoxy(30,10);
	printf("VALUE");
	for ( i = 0; i < n; i++ )
	{
		gotoxy(17,12+(2*i));
		printf("X%d",(i + 1));
		gotoxy(31,12+(2*i));
		printf("%.2f",x[i]);
	}
	getch();
}
/*-------------end of display function---------------------------------*/

void dis_mat(int n)
/*    function to display matrix */

{

	int i,j;

	clrscr();
	for ( i = 0; i < n; i++ )
	{
		for (j = 0; j < n; j++ )
			printf("\t %.2f",a[i][j]);
		printf("\t\t %.2f",cons[i]);
		printf("\n\n");
	}
	getch();
}
/*-----------------end of disp_mat--------------------------------*/

void swap(int i,int j,int n)

/* function to swap */
{
	float temp;
	int k;

	for ( k = 0; k < n; k++ )
	{
		temp = a[i][k];
		a[i][k] = a[j][k];
		a[j][k] = temp;
	}
}

/*---------------end of function swap------------------------------*/
void check_piv(int i,int n)

/* function to check the pivotal element and obtain proper
   pivotal element */

{
	int j,max_row;

	max_row = i;
	for (j = (i+1); j < n; j++ )
	{
		if ( fabs(a[j][i]) > fabs(a[i][i]) )
			max_row = j;
	}
	if ( max_row != i )
		swap(i,j,n);
}
/*-------------------end of function check_pivot----------------*/

void g_elimn(int n)
/* main function for gauss elimination */
{
	int i,j,k;
	float temp;

	for ( i = 0; i < n; i++ )
	{
		check_piv(i,n);
		temp = a[i][i];
		for ( k = 0; k < n; k++ )
			a[i][k] = (a[i][k] / temp);
		cons[i] = cons[i] / temp;
		for ( j = (i+1); j < n; j++ )
		{
			temp = a[j][i];
			for ( k = 0; k < n; k++ )
				a[j][k] = a[j][k] - (a[i][k] * temp);
			cons[j] = cons[j] - (cons[i] * temp);
		}
	}
}
 /*------------------end of function g_elim-------------------------*/

void back_subs(int n)

/* function for back substitution */
{
	int i,j;

	x[n - 1] = cons[n - 1] / a[n - 1][n - 1];
	for ( i = (n - 2); i >= 0; i-- )
	{
		x[i] = cons[i];
		for ( j = (n - 1); j > i; j-- )
			x[i] = x[i] - (x[j] * a[i][j]);
		x[i] = x[i] / a[i][i];
	}
}

/*------------------end of function back_subs----------------------*/

void main()
{
	int n;
	clrscr();

	printf("ENTER NUMBER OF VARIABLES : ");
	scanf("%d",&n);
	accept(n);
	g_elimn(n);
	dis_mat(n);
	back_subs(n);
	display(n);
}


/*-------------------------end of main program------------------*/






